/*=======================================================================

    Copyright 1993 (C) David Hinds - All Rights Reserved
    
    Source file coord.h Version 1.1, Updated 3/15/93

=======================================================================*/

#ifdef COORD_C
static char ident_h[] = "@(#) coord.h version 1.1 (3/15/93)";
#endif

/* Some random I/O functions */
void fputpdb(FILE *f, CoordType *a, const int_t npts);

/* Functions for manipulating structures */

typedef float_t rotate_t[3][3];
typedef float_t xlate_t[3];

void resize(CoordType *a, const int_t n, const float_t scale);
void invert(CoordType *a, const int_t n);
void Hinds_rotate(CoordType *a, const int_t n, rotate_t u);
void Hinds_translate(CoordType *a, const int_t n, const xlate_t t);
float_t distrms(CoordType *a, CoordType *b, const int_t npts);
/*
float_t justrms(dbl_t e0, dbl_t det, dbl_t spur, dbl_t cof);
void justbothrms(float_t *r1, float_t *r2,
                 dbl_t e0, dbl_t det, dbl_t spur, dbl_t cof);
float_t justbestrms(dbl_t e0, dbl_t det, dbl_t spur, dbl_t cof);
*/
float_t fitrms(CoordType *x, CoordType *y, const int_t npts);
void bothrms(CoordType *x, CoordType *y, const int_t npts,
             float_t *rms, float_t *invrms);
float_t bestrms(CoordType *x, CoordType *y, const int_t npts);
float_t bestfit(rotate_t u, xlate_t t,
                CoordType *a, CoordType *b, const int_t npts);
