/*                                                ++++++++        */
# define FILENAME                                 "util.c"
/*                                                ++++++++        */

#include "util.h"

/*   ====                                                                  */
void swap (char * a, char * b,int s)
/*   ====                                                                  */
{
  int i;
  char buf[BUFSIZ], *c = buf;

  if (s>BUFSIZ) {
    s = BUFSIZ;
    nonfatal(FILENAME,"swap","s>BUFSIZE");
  }
  for (i=0;i<s;i++) {
    *c=*a;
    *a++=*b;
    *b++=*c++;
  }
}


/*         #####                                                */      
static int STACK[MAXSTACK] = {0};
/*         #####                                                */      

/*         ####                                                            */
static int STKP =0;
/*         ####                                                            */

/*   ====                                                       */
int  push (char * a, int s)
/*   ====                                                       */
{
  int i=STKP;
  STKP += s;
  if (STKP > MAXSTACK) 
    nonfatal(FILENAME,"push","STKP>MAXSTACK");
  while (i<STKP) 
    STACK[i++]=*a++;
  return(STKP);
}
  
/*   ===                                                       */
int  pop (char * a, int s)
/*   ===                                                       */

{
  int i=STKP;
  int j = (STKP -= s);
  if (STKP < 0) 
    nonfatal(FILENAME,"pop","STKP<0");
  while (j < i ) 
    *a++=STACK[j++];
  return(STKP);
}  

/*     ====                                                       */
double ranf(double from, double to)
/*     ====                                                       */
{
  long r = random();
  double retval = (to - from) * ((double) r / (double) MAXRAND) + from ;
# ifdef OFF
  printf("%s (ranf): from=%9f to=%9f retval=%9f\n",FILENAME,from,to,retval);
# endif
  return retval;
}

/*
** Doesn't work 
*/
# ifdef OFF
/*   =========                                                       */
void old_fillarray(double *arr, double *arrn, double v)
/*   =========                                                       */
{
  while(arr != arrn) {
    *arr = v;
    arr++;
  }
}
# endif 

/*   =========                                                       */
void fillarray (double arr[], const int size, const double v) 
/*   =========                                                       */
{
  int i;

  for(i=0;i<size;i++)
    arr[i] = v;

}

/* --------                                                              */
   nonfatal (char *filename, char *function, char *message)
/* --------                                                              */
{
  fprintf(stderr,"\n\nnon-fatal error in %s (%s): %s\n\n", 
	  filename, function, message);
  fprintf(stdout,"\n\nnon-fatal error in %s (%s): %s\n\n", 
	  filename, function, message);
}

/*   ================                                                            */
void sleep_while_file (char stopfile[], int sleeptime)
/*   ================                                                            */
{
  char subr[] = "sleep_while_file";
  int  n = 0;
  FILE *stream;
  printf("%s (%s): %d sleeps for %d seconds until %s disappears.\n",
	 FILENAME,subr,getpid(),sleeptime,stopfile);
  printf(" : ZZZzzz.....\n");
  
  while ( (stream = fopen(stopfile,"r")) != NULL) {
    fclose(stream);
    sleep(sleeptime);
    n++;
  }    
  printf("%s (%s): %d wakes up after %d seconds.\n",
	 FILENAME,subr,getpid(),n*sleeptime);
}

/*   ========                                                       */
void prt_time (FILE *stream)
/*   ========                                                       */
{
  struct timeval tv;
  struct timezone tz;
  struct timeval *tp;
  struct timezone *tzp;
  long clocktime, *clock = &clocktime;

# ifdef OFF  
  gettimeofday(tp, tzp);
  fprintf(stream, "*tp= %ld\n", *tp);
  fprintf(stream, "ctime= %s\n", (char *) ctime( (long *) tp));
# endif
  clocktime = time(0);
  fprintf(stream, "ctime= %s", ctime( clock ));
}
    
  











